#ifndef _MATRIX_H_
#define _MATRIX_H_

#include <QString>

//start
class Matrix {
public:
    Matrix(int rows, int cols); // allocates and zeros all cells
    Matrix(const Matrix& mat);  // copy constructor - clones mat
    ~Matrix();
    double& operator()(int i, int j);
    double operator()(int i, int j) const;
    Matrix& operator=(const Matrix& mat); // deletes host content and clones mat
    Matrix operator+(const Matrix& mat) const; // matrix addition
    Matrix operator*(const Matrix& mat) const; // matrix multiplication
    bool operator==(const Matrix& mat) const;
    int getRows() const;
    int getCols() const;
    QString toString() const;
private:
    int m_Rows, m_Cols;
    double  **m_NumArray;
    void sweepClean(); // Refactoring utility
    void clone(const Matrix& mat); // Refactoring utility
    double rcprod(int row, const Matrix& mat, int col) const; // host-row dot mat-col
};
//end
#endif

